// WColorAttribute.cpp: implementation of the WColorAttribute class.
//
//////////////////////////////////////////////////////////////////////

#include "WColorAttribute.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


WColorAttribute::~WColorAttribute()
{

}



const BYTE	WColorAttribute::BLACK			= 0;
const BYTE	WColorAttribute::BLUE			= 1;
const BYTE	WColorAttribute::GREEN			= 2;
const BYTE	WColorAttribute::CYAN			= 3;
const BYTE	WColorAttribute::RED			= 4;
const BYTE	WColorAttribute::MAGENTA		= 5;
const BYTE	WColorAttribute::BROWN			= 6;
const BYTE	WColorAttribute::LIGHTGRAY		= 7;
const BYTE	WColorAttribute::DARKGRAY		= 8;
const BYTE	WColorAttribute::LIGHTBLUE		= 9;
const BYTE	WColorAttribute::LIGHTGREEN		= 10;
const BYTE	WColorAttribute::LIGHTCYAN		= 11;
const BYTE	WColorAttribute::LIGHTRED		= 12;
const BYTE	WColorAttribute::LIGHTMAGENTA	= 13;
const BYTE	WColorAttribute::YELLOW			= 14;
const BYTE	WColorAttribute::WHITE			= 15;
const BYTE	WColorAttribute::BLINK			= 128;
const BYTE	WColorAttribute::NORMAL_COLOR	= 7;



VOID WColorAttribute::AddToAnsiString
	(
	CHAR *pszAnsiString, 
	UINT i
	)
{
	CHAR szNumber[20];

	strcat(pszAnsiString, ";");
	itoa(i, szNumber, 10);
	strcat(pszAnsiString, szNumber);
}


VOID WColorAttribute::CreateAnsiStringFromAttribute
	(
	BYTE byAttribute, 
	LPSTR lpszAnsiAttributeString
	)
{
	_ASSERT(lpszAnsiAttributeString);

	// This is a mapping of ANSI values to MS-DOS style attribute values
	// You reference this as temp[<msdos-attribute number>]
	CHAR *temp = "04261537";

	// start off with initial ANSI escape sequence header
	strcpy(lpszAnsiAttributeString, "\x1b[");

	// add initial 0
    AddToAnsiString(lpszAnsiAttributeString, 0);

	// make it bold if it is supposed to be bold
    if (byAttribute & 0x08)
    {
      AddToAnsiString(lpszAnsiAttributeString, 1);
    }

	// add foreground color code
    AddToAnsiString(lpszAnsiAttributeString, 30 + temp[byAttribute & 0x07] - '0');

	// add background code
    AddToAnsiString(lpszAnsiAttributeString, 40 + temp[(byAttribute & 0x70) >> 4] - '0');

	// if the blink bit is set, add a '5'
    if (byAttribute & 0x80) 
	{
		AddToAnsiString(lpszAnsiAttributeString, 5);
    }

	// add trailing m to complete the escape sequence
	strcat(lpszAnsiAttributeString, "m");
}

