#ifndef __WCONSOLE_H__
#define __WCONSOLE_H__

#include <windows.h>
#include <tchar.h>
#include <crtdbg.h>		// MSCRT Debug Support (_ASSERT macro)

#include "WColorAttribute.h"
#include "WKey.h"
#include "WPoint.h"
#include "WRect.h"
//#include "WWindow.h"

class WScreen
{

private:

	// %TODO: Put data for the screen image

public:

	WScreen();
	
	~WScreen();

};



class WConsole
{

private:

// ----------------------------------------------------------------------------
// Output Console Handle
// ----------------------------------------------------------------------------
	HANDLE m_hConsoleOutput;

// ----------------------------------------------------------------------------
// Input Console Handle
// ----------------------------------------------------------------------------
	HANDLE m_hConsoleInput;

// ----------------------------------------------------------------------------
// Normal Cursor
// ----------------------------------------------------------------------------
	CONSOLE_CURSOR_INFO m_NormalCursorInfo;




// -----------------------------------------------------------------------
// Information about the screen
// -----------------------------------------------------------------------
	CONSOLE_SCREEN_BUFFER_INFO m_consoleScreenBufferInfo;


// ----------------------------------------------------------------------------
// Number of Last Error Code from Class
// ----------------------------------------------------------------------------
	UINT32	m_nLastErrorCode;




// enumerations

public:


	//
	// Cursor Style Constants
	//
	enum 
	{  
			CURSOR_OFF		= 0,
			CURSOR_NORMAL	= 1,
			CURSOR_BIG		= 2
	};

	
protected:

	WConsole();


public:
	// Destructor
	~WConsole();

	// Singleton point
	static WConsole& Instance();
	
	// Save/Restore Screen Operations
	WScreen*	GetScreenImage();
	VOID		SetScreenImage(WScreen* screen);
	VOID		SetConsoleCursor(UINT32 cursorStyle);

	// Housekeeping
	UINT32 GetLastErrorCode() 
	{ 
		return m_nLastErrorCode; 
	}
	
	WKey GetChar(BOOL bUseBlockingMode=FALSE);

	HANDLE	GetOutConsoleHandle();

	// Additional Console Interaction calls
    VOID SetConsoleTitle(LPCTSTR pszNewTitle);

    VOID ConsoleMessageBox(LPCTSTR pszText);
    VOID GetString(WPoint &point, PSTR szText, WORD wLen, TCHAR chType, PWORD pwDirection);


private:

	BOOL UpdateConsoleInfo()
	{
		return	GetConsoleScreenBufferInfo
				(
					m_hConsoleOutput,				// handle to console screen buffer
					&m_consoleScreenBufferInfo		// address of screen buffer info.
				);
	}
	
};



#endif // __WCONSOLE_H__