// WConsoleTestHarness.cpp: implementation of the WConsoleTestHarness class.
//
//////////////////////////////////////////////////////////////////////

#include "WConsoleTestHarness.h"


//
// Individual tests
//

BOOL ScrollTest1();
BOOL CharTest1();
BOOL OutputTest1();




//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

WConsoleTestHarness::WConsoleTestHarness()
{
}

WConsoleTestHarness::~WConsoleTestHarness()
{

}



VOID WConsoleTestHarness::Run(UINT32 nTestNumber)
{
	
	switch(nTestNumber)
	{
	case 1:
		{
			ScrollTest1();
		}
		break;
	case 2:
		{
			OutputTest1();
		}
		break;
	case 3:
		{
			CharTest1();
		}
		break;

	default:
		break;
	}

}


VOID WConsoleTestHarness::About()
{
	WPoint		point1	(0,			0);
	WPoint		point2	(79,		24);
	WRect		rect	(point1,	point2);
	WConsole	console = WConsole::Instance();
	WWindow		window(console, rect);
	TCHAR ch;
	window.ClearScreen();
	window.WriteString((WORD)14, "WConsole Class Test Harness\n");
	window.WriteString((WORD)9,  "===========================\n\n");
	window.WriteString((WORD)13, "[PAUSE]");
	ch = (TCHAR) console.GetChar(TRUE);
}


VOID WConsoleTestHarness::Menu()
{
	WPoint		point1	(0,			0);
	WPoint		point2	(79,		24);
	WRect		rect	(point1,	point2);
	WConsole	console = WConsole::Instance();
	WWindow		window(console, rect);
	TCHAR ch;
	bool bDone = false;
	while (!bDone)
	{
		window.ClearScreen();
		window.WriteString((WORD)14, "WConsole Class Test Harness\n");
		window.WriteString((WORD)9,  "===========================\n\n");
		window.WriteString((WORD)3,  "(1) Scroll Test #1\n");
		window.WriteString((WORD)3,  "(2) Output Test #1\n");
		window.WriteString((WORD)3,  "(3) Character Test #1\n");
		window.WriteString((WORD)3,  "(A) About the Test Harness\n\n");
		window.WriteString((WORD)3,  "(Q) Quit Test Harness\n\n");
		window.WriteString((WORD)9,  "Enter Command: ");
		ch = (TCHAR) console.GetChar(TRUE);

		switch (ch)
		{
		case 27:
		case 'q':
		case 'Q':
			bDone = true;
			break;
		case '1':
			this->Run(1);
			break;
		case 'a':
		case 'A':
			this->About();
			break;
		case '2':
			this->Run(2);
			break;
		case '3':
			this->Run(3);
			break;
		}
	}
	window.ClearScreen();
	window.WriteString((WORD)14, "Thank You for Using WConsole!\n\n");
}


BOOL CharTest1()
{
	WPoint		point1	(0,			0);
	WPoint		point2	(79,		24);
	WRect		rect	(point1,	point2);
	WConsole console = WConsole::Instance();
	WWindow		window(console, rect);
	BOOL		bDone = FALSE;
	WKey		key;
	CHAR		szText[41];

	window.ClearScreen();
	window.WriteString(14, "WConsole Input Test:\n");
	window.WriteString(9,  "====================\n");
	while (!bDone)
	{
		key = console.GetChar(TRUE);
		if ((BYTE)key.GetChar() == 27)
		{
			bDone = TRUE;
		}
		else
		{
			sprintf(szText, "Key = %d, Scan = %d\n", (BYTE)key.GetChar(), key.GetScanCode());
			window.WriteString(szText);
		}
	}
	return TRUE;
}

BOOL OutputTest1()
{
	WPoint		point1	(0,			0);
	WPoint		point2	(79,		24);
	WRect		rect	(point1,	point2);
	WConsole console = WConsole::Instance();
	WWindow		window(console, rect);
	TCHAR		szText[81];
	time_t		t0, t1;
	t0 = time(NULL);
	for (int i=0; i<15; i++)
	{
		window.WriteString("QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm1234567890/*-+!@#$%^&*()<>;ABCDEFG\n");
	}
	t1 = time(NULL);
	sprintf(szText, "Time elapsed = %d", (t1-t0));
	window.WriteString((WORD) 14, szText);
	window.WriteString((WORD)13, "[PAUSE]");
	console.GetChar(TRUE);
	return TRUE;
}	



BOOL ScrollTest1()
{
	// Test main
	WPoint		point1(0,0);
	WPoint		point2(79, 3);
	WRect		rect(point1, point2);

	WPoint		point3(0,4);
	WPoint		point4(79, 24);
	WRect		rect2(point3, point4);
	WConsole console = WConsole::Instance();	
	WWindow		window (console, rect);
	WWindow		window2(console, rect2);
	window2.ClearScreen();
	window.ClearScreen();

	TCHAR	szText[81];
	sprintf(szText, "%-80.80s", "Test");
	window.WriteString(WPoint(0, 0), 31, szText);
	window.WriteString(WPoint(0, 1), 31, szText);
	window.WriteString(WPoint(0, 2), 31, szText);
	window.WriteString(WPoint(0, 3), 31, szText);

	for (int i=0; i<200; i++)
	{
		window2.WriteString("Hello World!!\n");
	}

	bool bDone = false;
	TCHAR ch;
	WKey key;
	while (!bDone)
	{
		key = console.GetChar(TRUE);
		ch = key.GetChar();
		if (ch == 0)
		{
			switch (key.GetScanCode())
			{
			case 72:
				ch = '8';
				break;
			case 80:
				ch = '2';
				break;
			case 75:
				ch = '4';
				break;
			case 77:
				ch = '6';
				break;
			}
		}
		switch (ch)
		{
		case 27:
		case 'q':
		case 'Q':
			bDone = true;
			break;
		case 'H':
		case 'h':
		case '4':
			window2.ScrollWindowLeft(1);
			break;
		case 'J':
		case 'j':
		case '8':
			window2.ScrollWindowUp(1);
			break;
		case 'K':
		case 'k':
		case '2':
			window2.ScrollWindowDown(1);
			break;
		case 'L':
		case 'l':
		case '6':
			window2.ScrollWindowRight(1);
			break;
		default:
			break;
		}
	}
	return TRUE;
}



int main(int argc, char* argv[])
{
	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);

	WConsoleTestHarness *pTestHarness = new WConsoleTestHarness();
	pTestHarness->Menu();
	
	delete pTestHarness;
	return 0;
}
