// WPoint.h: interface for the WPoint class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WPOINT_H__AB2BE4C2_9A6A_11D3_8104_005004D580FD__INCLUDED_)
#define AFX_WPOINT_H__AB2BE4C2_9A6A_11D3_8104_005004D580FD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>
#include <tchar.h>
#include <crtdbg.h>		// MSCRT Debug Support (_ASSERT macro)


class WPoint  
{
private:

	INT32 m_cx;
	INT32 m_cy;

public:
	WPoint(INT32 x=0, INT32 y=0) 
	{ 
		m_cx=x; 
		m_cy=y; 
	}
	virtual ~WPoint();



	INT32		GetX() 
	{ 
		return m_cx; 
	}

	INT32		GetY() 
	{ 
		return m_cy; 
	}

	VOID	SetX(INT32 x) 
	{ 
		m_cx = x; 
	}

	VOID	SetY(INT32 y) 
	{ 
		m_cy = y; 
	}

	WPoint& operator =( const WPoint& srcPoint )
	{
		m_cx = srcPoint.m_cx;
		m_cy = srcPoint.m_cy;
		return *this;
	}

	VOID Inc(UINT nIncBy) 
	{
		m_cx+=nIncBy;
		m_cy+=nIncBy;
	}

	VOID Dec(UINT nDecBy)
	{
		m_cx-=nDecBy;
		m_cy-=nDecBy;

	}

};

#endif // !defined(AFX_WPOINT_H__AB2BE4C2_9A6A_11D3_8104_005004D580FD__INCLUDED_)


