// WRect.cpp: implementation of the WRect class.
//
//////////////////////////////////////////////////////////////////////

#include "WRect.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


WRect::~WRect()
{

}


WRect::WRect
	(
	WPoint& start, 
	WPoint& end
	)
{
	m_StartPoint	= start;
	m_EndPoint		= end;
}


	
WRect::WRect
	(
	int sx, 
	int sy, 
	int ex, 
	int ey
	)
{
	// Delegate to the previously listed constructor
	WRect(WPoint(sx, sy), WPoint(ex, ey));
}



int	WRect::GetLength()
{
	// Length is endpoint-Y minus startpoint-Y
	int nLength = m_EndPoint.GetY() - m_StartPoint.GetY() + 1;

	// return the length if it is greater than zero
	// return 0 if the length is less than zero
	return ((nLength>0) ? nLength : 0);
}


	
int WRect::GetWidth()
{
	// Width is endpoint-Y minus startpoint-=Y
	int nWidth = m_EndPoint.GetX() - m_StartPoint.GetX() + 1;

	// return the width if it is greater than zero
	// return 0 if the width is less than zero
	return ((nWidth>0) ? nWidth : 0);
}


