// WRect.h: interface for the WRect class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WRECT_H__AB2BE4C3_9A6A_11D3_8104_005004D580FD__INCLUDED_)
#define AFX_WRECT_H__AB2BE4C3_9A6A_11D3_8104_005004D580FD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>
#include <tchar.h>
#include <crtdbg.h>		// MSCRT Debug Support (_ASSERT macro)
#include "wpoint.h"

class WRect  
{

private:
	WPoint m_StartPoint;
	WPoint m_EndPoint;


public:
	WRect(WPoint& start, WPoint& end);
	
	WRect(INT32 sx=0, INT32 sy=0, INT32 ex=0, INT32 ey=0);

	virtual ~WRect();
	
	WPoint& GetStartPoint()
	{
		return m_StartPoint;
	}
	
	WPoint& GetEndPoint()
	{
		return m_EndPoint;
	}
	
	INT32	GetLength();
	
	INT32 GetWidth();
	
	INT32 GetStartX()
	{
		return m_StartPoint.GetX();
	}
	
	INT32 GetStartY()
	{
		return m_StartPoint.GetY();
	}
	
	INT32 GetEndX()
	{
		return m_EndPoint.GetX();
	}
	
	INT32 GetEndY()
	{
		return m_EndPoint.GetY();
	}

	WRect& operator =( const WRect& srcRect )
	{
		m_StartPoint = srcRect.m_StartPoint;
		m_EndPoint   = srcRect.m_EndPoint;
		return *this;
	}

	VOID Grow(UINT nGrowBy)
	{
		m_StartPoint.Dec(nGrowBy);
		m_EndPoint.Inc(nGrowBy);
	}

	VOID Shrink(UINT nShrinkBy)
	{
		m_StartPoint.Inc(nShrinkBy);
		m_EndPoint.Dec(nShrinkBy);
	}

};

#endif // !defined(AFX_WRECT_H__AB2BE4C3_9A6A_11D3_8104_005004D580FD__INCLUDED_)
